Index: trunk/LMDZ.MARS/libf/phymars/phyetat0.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/phyetat0.F90	(revision 1130)
+++ trunk/LMDZ.MARS/libf/phymars/phyetat0.F90	(revision 1130)
@@ -0,0 +1,314 @@
+subroutine phyetat0 (fichnom,tab0,Lmodif,nsoil,ngrid,nlay,nq, &
+                     day_ini,time0,tsurf,tsoil,emis,q2,qsurf,co2ice)
+
+!  use netcdf
+  use infotrac, only: nqtot, tname
+  use surfdat_h, only: phisfi, albedodat, z0, z0_default,&
+                       zmea, zstd, zsig, zgam, zthe
+  use control_mod, only: timestart
+  use iostart, only: nid_start, open_startphy, close_startphy, &
+                     get_field, get_var, inquire_field, &
+                     inquire_dimension, inquire_dimension_length
+  implicit none
+!======================================================================
+! Auteur(s) Z.X. Li (LMD/CNRS) date: 19930818
+!  Adaptation à Mars : Yann Wanherdrick 
+! Objet: Lecture de l etat initial pour la physique
+! Modifs: Aug.2010 EM : use NetCDF90 to load variables (enables using
+!                      r4 or r8 restarts independently of having compiled
+!                      the GCM in r4 or r8)
+!         June 2013 TN : Possibility to read files with a time axis
+!         November 2013 EM : Enabeling parallel, using iostart module
+!======================================================================
+!#include "netcdf.inc"
+!#include "dimensions.h"
+!#include "dimphys.h"
+!#include "comgeomfi.h"
+!#include "surfdat.h"
+#include "planete.h"
+!#include "dimradmars.h"
+!#include "yomaer.h"
+#include "comcstfi.h"
+!#include "tracer.h"
+!#include "advtrac.h"
+!#include "control.h"
+!======================================================================
+  INTEGER nbsrf !Mars nbsrf a 1 au lieu de 4
+  PARAMETER (nbsrf=1) ! nombre de sous-fractions pour une maille
+!======================================================================
+!  Arguments:
+!  ---------
+!  inputs:
+  character*(*),intent(in) :: fichnom ! "startfi.nc" file
+  integer,intent(in) :: tab0
+  integer,intent(in) :: Lmodif
+  integer,intent(in) :: nsoil ! # of soil layers
+  integer,intent(in) :: ngrid ! # of atmospheric columns
+  integer,intent(in) :: nlay ! # of atmospheric layers
+  integer,intent(in) :: nq
+  integer :: day_ini
+  real :: time0
+
+!  outputs:
+  real,intent(out) :: tsurf(ngrid) ! surface temperature
+  real,intent(out) :: tsoil(ngrid,nsoil) ! soil temperature
+  real,intent(out) :: emis(ngrid) ! surface emissivity
+  real,intent(out) :: q2(ngrid,nlay+1) ! 
+  real,intent(out) :: qsurf(ngrid,nq) ! tracers on surface
+  real,intent(out) :: co2ice(ngrid) ! co2 ice cover
+
+!======================================================================
+!  Local variables:
+
+      real surffield(ngrid) ! to temporarily store a surface field
+      real xmin,xmax ! to display min and max of a field
+!
+      INTEGER ig,iq,lmax
+      INTEGER nid, nvarid
+      INTEGER ierr, i, nsrf
+!      integer isoil 
+!      INTEGER length
+!      PARAMETER (length=100)
+      CHARACTER*7 str7
+      CHARACTER*2 str2
+      CHARACTER*1 yes
+!
+      REAL p_rad,p_omeg,p_g,p_mugaz,p_daysec
+      INTEGER nqold
+
+! flag which identifies if 'startfi.nc' file is using old names (qsurf01,...)
+      logical :: oldtracernames=.false.
+      integer :: count
+      character(len=30) :: txt ! to store some text
+
+! specific for time 
+      REAL,ALLOCATABLE :: time(:) ! times stored in start
+      INTEGER timelen ! number of times stored in the file
+      INTEGER indextime ! index of selected time
+
+      INTEGER :: edges(3),corner(3)
+      LOGICAL :: found
+
+! open physics initial state file:
+call open_startphy(fichnom)
+
+
+! possibility to modify tab_cntrl in tabfi
+write(*,*)
+write(*,*) 'TABFI in phyeta0: Lmodif=',Lmodif," tab0=",tab0
+call tabfi (nid_start,Lmodif,tab0,day_ini,lmax,p_rad, &
+            p_omeg,p_g,p_mugaz,p_daysec,time0)
+
+
+! Load surface geopotential:
+call get_field("phisfi",phisfi,found)
+if (.not.found) then
+  write(*,*) "phyetat0: Failed loading <phisfi>"
+  call abort
+else
+  write(*,*) "phyetat0: surface geopotential <phisfi> range:", &
+             minval(phisfi), maxval(phisfi)
+endif
+
+
+! Load bare ground albedo:
+call get_field("albedodat",albedodat,found)
+if (.not.found) then
+  write(*,*) "phyetat0: Failed loading <albedodat>"
+  call abort
+else
+  write(*,*) "phyetat0: Bare ground albedo <albedodat> range:", &
+             minval(albedodat), maxval(albedodat)
+endif
+
+! ZMEA
+call get_field("ZMEA",zmea,found)
+if (.not.found) then
+  write(*,*) "phyetat0: Failed loading <ZMEA>"
+  call abort
+else
+  write(*,*) "phyetat0: <ZMEA> range:", &
+             minval(zmea), maxval(zmea)
+endif
+
+
+! ZSTD
+call get_field("ZSTD",zstd,found)
+if (.not.found) then
+  write(*,*) "phyetat0: Failed loading <ZSTD>"
+  call abort
+else
+  write(*,*) "phyetat0: <ZSTD> range:", &
+             minval(zstd), maxval(zstd)
+endif
+
+
+! ZSIG
+call get_field("ZSIG",zsig,found)
+if (.not.found) then
+  write(*,*) "phyetat0: Failed loading <ZSIG>"
+  call abort
+else
+  write(*,*) "phyetat0: <ZSIG> range:", &
+             minval(zsig), maxval(zsig)
+endif
+
+
+! ZGAM
+call get_field("ZGAM",zgam,found)
+if (.not.found) then
+  write(*,*) "phyetat0: Failed loading <ZGAM>"
+  call abort
+else
+  write(*,*) "phyetat0: <ZGAM> range:", &
+             minval(zgam), maxval(zgam)
+endif
+
+
+! ZTHE
+call get_field("ZTHE",zthe,found)
+if (.not.found) then
+  write(*,*) "phyetat0: Failed loading <ZTHE>"
+  call abort
+else
+  write(*,*) "phyetat0: <ZTHE> range:", &
+             minval(zthe), maxval(zthe)
+endif
+
+      
+! Time axis
+found=inquire_dimension("Time")
+if (.not.found) then
+  indextime = 1
+  write(*,*) "phyetat0: No time axis found in "//trim(fichnom)
+else
+  write(*,*) "phyetat0: Time axis found in "//trim(fichnom)
+  timelen=inquire_dimension_length("Time")
+  allocate(time(timelen))
+  ! load "Time" array:
+  call get_var("Time",time,found)
+  if (.not.found) then
+    write(*,*) "phyetat0: Failed loading <Time>"
+    call abort
+  endif
+  ! seclect the desired time index
+  IF (timestart .lt. 0) THEN  ! default: we use the last time value
+    indextime = timelen
+  ELSE  ! else we look for the desired value in the time axis
+    indextime = 0
+    DO i=1,timelen
+      IF (abs(time(i) - timestart) .lt. 0.01) THEN
+        indextime = i
+        EXIT
+      ENDIF
+    ENDDO
+    IF (indextime .eq. 0) THEN
+      PRINT*, "Time", timestart," is not in "//trim(fichnom)//"!!"
+      PRINT*, "Stored times are:"
+      DO i=1,timelen
+         PRINT*, time(i)
+      ENDDO
+      CALL abort
+    ENDIF
+  ENDIF ! of IF (timestart .lt. 0)
+  ! In startfi the absolute date is day_ini + time0 + time
+  ! For now on, in the GCM physics, it is day_ini + time0
+  time0 = time(indextime) + time0
+  day_ini = day_ini + INT(time0)
+  time0 = time0 - INT(time0)
+        
+  PRINT*, "phyetat0: Selected time ",time(indextime), &
+          " at index ",indextime
+     
+  DEALLOCATE(time)
+endif ! of if Time not found in file
+
+
+! CO2 ice cover
+call get_field("co2ice",co2ice,found,indextime)
+if (.not.found) then
+  write(*,*) "phyetat0: Failed loading <co2ice>"
+  call abort
+else
+  write(*,*) "phyetat0: CO2 ice cover <co2ice> range:", &
+             minval(co2ice), maxval(co2ice)
+endif
+
+
+! Surface temperature :
+call get_field("tsurf",tsurf,found,indextime)
+if (.not.found) then
+  write(*,*) "phyetat0: Failed loading <tsurf>"
+  call abort
+else
+  write(*,*) "phyetat0: Surface temperature <tsurf> range:", &
+             minval(tsurf), maxval(tsurf)
+endif
+
+! Surface emissivity
+call get_field("emis",emis,found,indextime)
+if (.not.found) then
+  write(*,*) "phyetat0: Failed loading <emis>"
+  call abort
+else
+  write(*,*) "phyetat0: Surface emissivity <emis> range:", &
+             minval(emis), maxval(emis)
+endif
+
+
+! surface roughness length (NB: z0 is a common in surfdat_h)
+call get_field("z0",z0,found)
+if (.not.found) then
+  write(*,*) "phyetat0: Failed loading <z0>"
+  write(*,*) 'will use constant value of z0_default:',z0_default
+  z0(:)=z0_default
+else
+  write(*,*) "phyetat0: Surface roughness <z0> range:", &
+             minval(z0), maxval(z0)
+endif
+
+
+! pbl wind variance
+call get_field("q2",q2,found,indextime)
+if (.not.found) then
+  write(*,*) "phyetat0: Failed loading <q2>"
+  call abort
+else
+  write(*,*) "phyetat0: PBL wind variance <q2> range:", &
+             minval(q2), maxval(q2)
+endif
+
+
+! tracer on surface
+if (nq.ge.1) then
+  do iq=1,nq
+    txt=tname(iq)
+    if (txt.eq."h2o_vap") then
+      ! There is no surface tracer for h2o_vap;
+      ! "h2o_ice" should be loaded instead
+      txt="h2o_ice"
+      write(*,*) 'phyetat0: loading surface tracer', &
+                           ' h2o_ice instead of h2o_vap'
+    endif
+    call get_field(txt,qsurf(:,iq),found,indextime)
+    if (.not.found) then
+      write(*,*) "phyetat0: Failed loading <",trim(txt),">"
+      write(*,*) "         ",trim(txt)," is set to zero"
+    else
+      write(*,*) "phyetat0: Surface tracer <",trim(txt),"> range:", &
+                 minval(qsurf(:,iq)), maxval(qsurf(:,iq))
+    endif
+  enddo
+endif ! of if (nq.ge.1)
+
+! Call to soil_settings, in order to read soil temperatures,
+! as well as thermal inertia and volumetric heat capacity
+
+      call soil_settings(nid_start,ngrid,nsoil,tsurf,tsoil,indextime)
+
+!
+! close file:
+!
+      call close_startphy
+
+      END
Index: trunk/LMDZ.MARS/libf/phymars/phyredem.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/phyredem.F90	(revision 1130)
+++ trunk/LMDZ.MARS/libf/phymars/phyredem.F90	(revision 1130)
@@ -0,0 +1,231 @@
+!
+! $Id: $
+!
+module phyredem
+
+implicit none
+
+contains
+
+subroutine physdem0(filename,lonfi,latfi,nsoil,ngrid,nlay,nq, &
+                         phystep,day_ini,time,airefi, &
+                         alb,ith,pzmea,pzstd,pzsig,pzgam,pzthe)
+! create physics restart file and write time-independent variables
+  use infotrac, only: nqtot, tname
+  use comsoil_h, only: inertiedat, volcapa, mlayer
+  use comgeomfi_h, only: area
+  use surfdat_h, only: albedodat, zmea, zstd, zsig, zgam, zthe, &
+                       z0_default, albedice, emisice, emissiv, &
+                       iceradius, dtemisice, phisfi, z0
+  use yomaer_h, only: tauvis
+  use iostart, only : open_restartphy, close_restartphy, & 
+                      put_var, put_field, length
+  use mod_grid_phy_lmdz, only : klon_glo
+
+  implicit none
+#include "planete.h"
+#include "comcstfi.h"
+ 
+  character(len=*), intent(in) :: filename
+  real,intent(in) :: lonfi(ngrid)
+  real,intent(in) :: latfi(ngrid)
+  integer,intent(in) :: nsoil
+  integer,intent(in) :: ngrid
+  integer,intent(in) :: nlay
+  integer,intent(in) :: nq
+  real,intent(in) :: phystep
+  real,intent(in) :: day_ini
+  real,intent(in) :: time
+  real,intent(in) :: airefi(ngrid)
+  real,intent(in) :: alb(ngrid)
+  real,intent(in) :: ith(ngrid,nsoil)
+  real,intent(in) :: pzmea(ngrid)
+  real,intent(in) :: pzstd(ngrid)
+  real,intent(in) :: pzsig(ngrid)
+  real,intent(in) :: pzgam(ngrid)
+  real,intent(in) :: pzthe(ngrid)
+ 
+  real :: tab_cntrl(length) ! nb "length=100" defined in iostart module
+  
+  ! Create physics start file
+  call open_restartphy(filename)
+  
+  ! Build tab_cntrl(:) array
+  tab_cntrl(:)=0.0
+  !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+  ! Fill control array tab_cntrl(:) with parameters for this run
+  !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+  ! Informations on the physics grid
+  tab_cntrl(1) = float(klon_glo)  ! total number of nodes on physics grid
+  tab_cntrl(2) = float(nlay) ! number of atmospheric layers
+  tab_cntrl(3) = day_ini + int(time)      ! initial day 
+  tab_cntrl(4) = time -int(time)          ! initial time of day
+
+  ! Informations about Mars, used by dynamics and physics
+  tab_cntrl(5) = rad      ! radius of Mars (m) ~3397200
+  tab_cntrl(6) = omeg     ! rotation rate (rad.s-1)
+  tab_cntrl(7) = g        ! gravity (m.s-2) ~3.72
+  tab_cntrl(8) = mugaz    ! Molar mass of the atmosphere (g.mol-1) ~43.49
+  tab_cntrl(9) = rcp      !  = r/cp  ~0.256793 (=kappa dans dynamique)
+  tab_cntrl(10) = daysec  ! length of a sol (s)  ~88775
+
+  tab_cntrl(11) = phystep  ! time step in the physics
+  tab_cntrl(12) = 0.
+  tab_cntrl(13) = 0.
+
+  ! Informations about Mars, only for physics
+  tab_cntrl(14) = year_day  ! length of year (sols) ~668.6
+  tab_cntrl(15) = periheli  ! min. Sun-Mars distance (Mkm) ~206.66
+  tab_cntrl(16) = aphelie   ! max. SUn-Mars distance (Mkm) ~249.22
+  tab_cntrl(17) = peri_day  ! date of perihelion (sols since N. spring)
+  tab_cntrl(18) = obliquit  ! Obliquity of the planet (deg) ~23.98
+
+  ! Boundary layer and turbulence
+  tab_cntrl(19) = z0_default   ! default surface roughness (m) ~0.01
+  tab_cntrl(20) = lmixmin   ! mixing length ~100
+  tab_cntrl(21) = emin_turb ! minimal energy ~1.e-8
+
+  ! Optical properties of polar caps and ground emissivity
+  tab_cntrl(22) = albedice(1)  ! Albedo of northern cap ~0.5
+  tab_cntrl(23) = albedice(2)  ! Albedo of southern cap ~0.5
+  tab_cntrl(24) = emisice(1)   ! Emissivity of northern cap ~0.95
+  tab_cntrl(25) = emisice(2)   ! Emissivity of southern cap ~0.95
+  tab_cntrl(26) = emissiv      ! Emissivity of martian soil ~.95
+  tab_cntrl(31) = iceradius(1) ! mean scat radius of CO2 snow (north)
+  tab_cntrl(32) = iceradius(2) ! mean scat radius of CO2 snow (south)
+  tab_cntrl(33) = dtemisice(1) ! time scale for snow metamorphism (north)
+  tab_cntrl(34) = dtemisice(2) ! time scale for snow metamorphism (south)
+
+  ! dust aerosol properties
+  tab_cntrl(27) = tauvis      ! mean visible optical depth
+
+  ! Soil properties:
+  tab_cntrl(35) = volcapa ! soil volumetric heat capacity
+
+  ! Write the controle array
+  call put_var("controle","Control parameters",tab_cntrl)
+  
+  ! Write the mid-layer depths
+  call put_var("soildepth","Soil mid-layer depth",mlayer)
+  
+  ! Write longitudes
+  call put_field("longitude","Longitudes of physics grid",lonfi)
+  
+  ! Write latitudes
+  call put_field("latitude","Latitudes of physics grid",latfi)
+  
+  ! Write mesh areas
+  call put_field("area","Mesh area",area)
+  
+  ! Write surface geopotential
+  call put_field("phisfi","Geopotential at the surface",phisfi)
+  
+  ! Write surface albedo
+  call put_field("albedodat","Albedo of bare ground",albedodat)
+  
+  ! Subgrid topogaphy variables
+  call put_field("ZMEA","Relief: mean relief",zmea)
+  call put_field("ZSTD","Relief: standard deviation",zstd)
+  call put_field("ZSIG","Relief: sigma parameter",zsig)
+  call put_field("ZGAM","Relief: gamma parameter",zgam)
+  call put_field("ZTHE","Relief: theta parameter",zthe)
+  
+  ! Soil thermal inertia
+  call put_field("inertiedat","Soil thermal inertia",inertiedat)
+  
+  ! Surface roughness length
+  call put_field("z0","Surface roughness length",z0)
+  
+  ! Close file
+  call close_restartphy
+  
+end subroutine physdem0
+
+subroutine physdem1(filename,nsoil,ngrid,nlay,nq, &
+                    phystep,time,tsurf,tsoil,co2ice,emis,q2,qsurf)
+  ! write time-dependent variable to restart file
+  use iostart, only : open_restartphy, close_restartphy, & 
+                      put_var, put_field
+  use infotrac, only: nqtot, tname
+  implicit none
+  character(len=*),intent(in) :: filename
+  integer,intent(in) :: nsoil
+  integer,intent(in) :: ngrid
+  integer,intent(in) :: nlay
+  integer,intent(in) :: nq
+  real,intent(in) :: phystep
+  real,intent(in) :: time
+  real,intent(in) :: tsurf(ngrid)
+  real,intent(in) :: tsoil(ngrid,nsoil)
+  real,intent(in) :: co2ice(ngrid)
+  real,intent(in) :: emis(ngrid)
+  real,intent(in) :: q2(ngrid,nlay+1)
+  real,intent(in) :: qsurf(ngrid,nq)
+  
+  integer :: iq
+  character(len=30) :: txt ! to store some text
+  ! indexes of water vapour & water ice tracers (if any):
+  integer :: i_h2o_vap=0
+  integer :: i_h2o_ice=0
+
+  
+  ! Open file
+  call open_restartphy(filename)
+  
+  ! First variable to write must be "Time", in order to correctly
+  ! set time counter in file
+  call put_var("Time","Temps de simulation",time)
+  
+  ! CO2 ice layer
+  call put_field("co2ice","CO2 ice cover",co2ice,time)
+  
+  ! Surface temperature
+  call put_field("tsurf","Surface temperature",tsurf,time)
+  
+  ! Soil temperature
+  call put_field("tsoil","Soil temperature",tsoil,time)
+  
+  ! Emissivity of the surface
+  call put_field("emis","Surface emissivity",emis,time)
+  
+  ! Planetary Boundary Layer
+  call put_field("q2","pbl wind variance",q2,time)
+  
+  ! Tracers on the surface
+  ! preliminary stuff: look for water vapour & water ice tracers (if any)
+  do iq=1,nq
+    if (tname(iq).eq."h2o_vap") then
+      i_h2o_vap=iq
+    endif
+    if (tname(iq).eq."h2o_ice") then
+      i_h2o_ice=iq
+    endif
+  enddo
+  
+  if (nq.gt.0) then
+    do iq=1,nq
+      txt=tname(iq)
+      ! Exception: there is no water vapour surface tracer
+      if (txt.eq."h2o_vap") then
+        write(*,*)"physdem1: skipping water vapour tracer"
+        if (i_h2o_ice.eq.i_h2o_vap) then
+          ! then there is no "water ice" tracer; but still
+          ! there is some water ice on the surface
+          write(*,*)"          writing water ice instead"
+          txt="h2o_ice"
+        else
+          ! there is a "water ice" tracer which has been / will be
+          ! delt with in due time
+          cycle
+        endif ! of if (igcm_h2o_ice.eq.igcm_h2o_vap)
+      endif ! of if (txt.eq."h2o_vap")
+      call put_field(trim(txt),"tracer on surface",qsurf(:,iq),time)
+    enddo
+  endif
+  
+  ! Close file
+  call close_restartphy
+  
+end subroutine physdem1
+
+end module phyredem
Index: trunk/LMDZ.MARS/libf/phymars/physiq.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/physiq.F	(revision 1127)
+++ trunk/LMDZ.MARS/libf/phymars/physiq.F	(revision 1130)
@@ -28,4 +28,6 @@
       use slope_mod, only: theta_sl, psi_sl
       use conc_mod, only: rnew, cpnew, mmean
+      use control_mod, only: iphysiq, day_step, ecritstart
+      use phyredem, only: physdem0, physdem1
 
 #ifdef MESOSCALE
@@ -144,5 +146,5 @@
 #include "planete.h"
 !#include "comsaison.h"
-#include "control.h"
+!#include "control.h"
 !#include "dimradmars.h"
 ! naerkind is set in scatterers.h (built when compiling with makegcm -s #)
@@ -515,9 +517,10 @@
 #ifndef MESOSCALE
          if (callslope) call getslopes(ngrid,phisfi)
-                           
+
+         if (ngrid.ne.1) then ! no need to create a restart file in 1d
          call physdem0("restartfi.nc",long,lati,nsoilmx,ngrid,nlayer,nq,
      .                 ptimestep,pday,time_phys,area,
      .                 albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe)
-     
+         endif
 #endif
                    
@@ -676,5 +679,4 @@
 c          Radiative transfer
 c          ------------------
-
            CALL callradite(icount,ngrid,nlayer,nq,zday,zls,pq,albedo,
      $     emis,mu0,zplev,zplay,pt,tsurf,fract,dist_sol,igout,
@@ -1036,5 +1038,5 @@
      &                nq,tau,tauscaling,rdust,rice,nuice,
      &                rsedcloud,rhocloud)
-
+     
 c Temperature variation due to latent heat release
            if (activice) then
@@ -1135,7 +1137,5 @@
 c        ------------- 
          IF (sedimentation) THEN 
-           !call zerophys(ngrid*nlayer*nq, zdqsed)
            zdqsed(1:ngrid,1:nlayer,1:nq)=0
-           !call zerophys(ngrid*nq, zdqssed)
            zdqssed(1:ngrid,1:nq)=0
 
@@ -2073,10 +2073,12 @@
      &                       'Mean reff',
      &                       'm',2,rave)
-            CALL WRITEDIAGFI(ngrid,"Nccntot",
+            if (scavenging) then
+              CALL WRITEDIAGFI(ngrid,"Nccntot",
      &                    "condensation nuclei","Nbr/m2",
      &                    2,Nccntot)
-            CALL WRITEDIAGFI(ngrid,"Mccntot",
+              CALL WRITEDIAGFI(ngrid,"Mccntot",
      &                    "mass condensation nuclei","kg/m2",
      &                    2,Mccntot)
+            endif
             call WRITEDIAGFI(ngrid,'rice','Ice particle size',
      &                       'm',3,rice)
Index: trunk/LMDZ.MARS/libf/phymars/planete.h
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/planete.h	(revision 1127)
+++ trunk/LMDZ.MARS/libf/phymars/planete.h	(revision 1130)
@@ -1,4 +1,4 @@
-c-----------------------------------------------------------------------
-c INCLUDE planet.h
+!-----------------------------------------------------------------------
+! INCLUDE planet.h
 
       COMMON/planet/aphelie,periheli,year_day,peri_day,                 &
@@ -12,3 +12,3 @@
      &       timeperi,e_elips,p_elips,unitastr
 
-c-----------------------------------------------------------------------
+!-----------------------------------------------------------------------
Index: trunk/LMDZ.MARS/libf/phymars/planetwide_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/planetwide_mod.F90	(revision 1130)
+++ trunk/LMDZ.MARS/libf/phymars/planetwide_mod.F90	(revision 1130)
@@ -0,0 +1,203 @@
+!
+! $Id: $
+!
+module planetwide_mod
+! module which contains functions to obtain max/min/... values over the
+! entire globe (trivial in serial mode, but not in parallel)
+
+use mod_phys_lmdz_para, only : is_master, gather, bcast
+                               
+implicit none
+
+interface planetwide_maxval ! maxval() , over the entire planet
+  module procedure planetwide_maxval_i1, planetwide_maxval_i2, &
+                   planetwide_maxval_r1, planetwide_maxval_r2
+end interface
+
+interface planetwide_minval ! minval() , over the entire planet
+  module procedure planetwide_minval_i1, planetwide_minval_i2, &
+                   planetwide_minval_r1, planetwide_minval_r2
+end interface
+
+contains
+
+  subroutine planetwide_maxval_i1(values,values_max)
+  use dimphy, only: klon
+  use mod_grid_phy_lmdz, only : klon_glo
+  implicit none
+  integer,intent(in) :: values(:) ! local grid (klon)
+  integer,intent(out) :: values_max
+#ifdef CPP_PARA
+  integer :: values_glo(klon_glo) ! global grid
+  
+  ! gather field on master:
+  call gather(values,values_glo)
+  ! extract maximum value
+  if (is_master) then
+    values_max=maxval(values_glo)
+  endif
+  ! broadcast information to all cores
+  call bcast(values_max)
+#else
+  values_max=maxval(values)
+#endif
+  end subroutine planetwide_maxval_i1
+
+  subroutine planetwide_maxval_i2(values,values_max)
+  use dimphy, only: klon, klev
+  use mod_grid_phy_lmdz, only : klon_glo
+  implicit none
+  integer,intent(in) :: values(:,:) ! local grid (klon,klev)
+  integer,intent(out) :: values_max
+#ifdef CPP_PARA
+  integer :: values_glo(klon_glo,klev) ! global grid
+  
+  ! gather field on master:
+  call gather(values,values_glo)
+  ! extract maximum value
+  if (is_master) then
+    values_max=maxval(values_glo)
+  endif
+  ! broadcast information to all cores
+  call bcast(values_max)
+#else
+  values_max=maxval(values)
+#endif
+  end subroutine planetwide_maxval_i2
+
+  subroutine planetwide_maxval_r1(values,values_max)
+  use dimphy, only: klon
+  use mod_grid_phy_lmdz, only : klon_glo
+  implicit none
+  real,intent(in) :: values(:) ! local grid (klon)
+  real,intent(out) :: values_max
+#ifdef CPP_PARA
+  real :: values_glo(klon_glo) ! global grid
+  
+  ! gather field on master:
+  call gather(values,values_glo)
+  ! extract maximum value
+  if (is_master) then
+    values_max=maxval(values_glo)
+  endif
+  ! broadcast information to all cores
+  call bcast(values_max)
+#else
+  values_max=maxval(values)
+#endif
+  end subroutine planetwide_maxval_r1
+
+  subroutine planetwide_maxval_r2(values,values_max)
+  use dimphy, only: klon, klev
+  use mod_grid_phy_lmdz, only : klon_glo
+  implicit none
+  real,intent(in) :: values(:,:) ! local grid (klon,klev)
+  real,intent(out) :: values_max
+#ifdef CPP_PARA
+  real :: values_glo(klon_glo,klev) ! global grid
+  
+  ! gather field on master:
+  call gather(values,values_glo)
+  ! extract maximum value
+  if (is_master) then
+    values_max=maxval(values_glo)
+  endif
+  ! broadcast information to all cores
+  call bcast(values_max)
+#else
+  values_max=maxval(values)
+#endif
+  end subroutine planetwide_maxval_r2
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+  subroutine planetwide_minval_i1(values,values_max)
+  use dimphy, only: klon
+  use mod_grid_phy_lmdz, only : klon_glo
+  implicit none
+  integer,intent(in) :: values(:) ! local grid (klon)
+  integer,intent(out) :: values_max
+#ifdef CPP_PARA
+  integer :: values_glo(klon_glo) ! global grid
+  
+  ! gather field on master:
+  call gather(values,values_glo)
+  ! extract maximum value
+  if (is_master) then
+    values_max=minval(values_glo)
+  endif
+  ! broadcast information to all cores
+  call bcast(values_max)
+#else
+  values_max=minval(values)
+#endif
+  end subroutine planetwide_minval_i1
+
+  subroutine planetwide_minval_i2(values,values_max)
+  use dimphy, only: klon, klev
+  use mod_grid_phy_lmdz, only : klon_glo
+  implicit none
+  integer,intent(in) :: values(:,:) ! local grid (klon,klev)
+  integer,intent(out) :: values_max
+#ifdef CPP_PARA
+  integer :: values_glo(klon_glo,klev) ! global grid
+  
+  ! gather field on master:
+  call gather(values,values_glo)
+  ! extract maximum value
+  if (is_master) then
+    values_max=minval(values_glo)
+  endif
+  ! broadcast information to all cores
+  call bcast(values_max)
+#else
+  values_max=minval(values)
+#endif
+  end subroutine planetwide_minval_i2
+
+  subroutine planetwide_minval_r1(values,values_max)
+  use dimphy, only: klon
+  use mod_grid_phy_lmdz, only : klon_glo
+  implicit none
+  real,intent(in) :: values(:) ! local grid (klon)
+  real,intent(out) :: values_max
+#ifdef CPP_PARA
+  real :: values_glo(klon_glo) ! global grid
+  
+  ! gather field on master:
+  call gather(values,values_glo)
+  ! extract maximum value
+  if (is_master) then
+    values_max=minval(values_glo)
+  endif
+  ! broadcast information to all cores
+  call bcast(values_max)
+#else
+  values_max=minval(values)
+#endif
+  end subroutine planetwide_minval_r1
+
+  subroutine planetwide_minval_r2(values,values_max)
+  use dimphy, only: klon, klev
+  use mod_grid_phy_lmdz, only : klon_glo
+  implicit none
+  real,intent(in) :: values(:,:) ! local grid (klon,klev)
+  real,intent(out) :: values_max
+#ifdef CPP_PARA
+  real :: values_glo(klon_glo,klev) ! global grid
+  
+  ! gather field on master:
+  call gather(values,values_glo)
+  ! extract maximum value
+  if (is_master) then
+    values_max=minval(values_glo)
+  endif
+  ! broadcast information to all cores
+  call bcast(values_max)
+#else
+  values_max=minval(values)
+#endif
+  end subroutine planetwide_minval_r2
+
+
+end module planetwide_mod
